import { createRoute, OpenAPIHono, z } from "@hono/zod-openapi";
import { responses } from "../../../globalUtils/routeDefs/responses.js";
import { tryCatch } from "../../../globalUtils/tryCatch.js";
import { apiHit } from "../../../globalUtils/apiHits.js";
import { removeAsNonReusable } from "../controller/commands/removeAsNonReusable.js";

const app = new OpenAPIHono();

// const Body = z
//     .object({
//         age: z.number().optional().openapi({ example: 90 }),
//         //email: z.string().optional().openapi({example: "s.smith@example.com"}),
//         type: z.string().optional().openapi({ example: "fg" }),
//     })
//     .openapi("User");
app.openapi(
    createRoute({
        tags: ["logistics"],
        summary:
            "Remove a pallet similar to stock out from the system with a reason",
        method: "post",
        path: "/removeasreusable",
        // request: {
        //     body: {
        //         content: {
        //             "application/json": { schema: Body },
        //         },
        //     },
        // },
        // description:
        //     "Provided a running number and lot number you can consume material.",
        responses: responses(),
    }),
    async (c: any) => {
        apiHit(c, { endpoint: "/removeasreusable" });
        const { data: body, error: be } = await tryCatch(c.req.json());

        if (be) {
            return {
                success: false,
                message: "Missing data",
                data: [],
            };
        }
        const { data, error } = await tryCatch(removeAsNonReusable(body));

        if (error) {
            return c.json({
                success: false,
                message: "Error getting lane data.",
                data: error,
            });
        }

        return c.json({
            success: data.success,
            message: data.message,
            data: data.data,
        });
    }
);
export default app;
